<template>
  <div class="q-pa-md">
    <q-table
      title="Products"
      :rows="products"
      row-key="id"
      :columns="columns"
      :selected-rows-label="getSelectedString"
      selection="multiple"
      v-model:selected="selected"
    >
      <template v-slot:body-cell-img="products">
        <q-td :products="products" align="left">
          <q-img :src="products.row.img" spinner-color="white" />
        </q-td>
      </template>
      <template v-slot:body-cell-category="products">
        <q-td :products="products" align="left">
          {{ products.row.category.name }}
        </q-td>
      </template>
      <template v-slot:body-cell-action="products">
        <q-td :products="products" align="left" width="20px">
          <q-btn
            color="primary"
            icon="edit"
            @click="ShowEditModal(products.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
          <q-btn
            color="red"
            icon="delete"
            @click="ShowDeleteModal(products.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
        </q-td>
      </template>
      <template v-slot:top>
        <q-btn
          color="primary"
          :disable="loading"
          label="Add Product"
          @click="ShowAddModal()"
        />
        <q-btn
          v-if="selected.length"
          class="q-ml-sm"
          color="red"
          :disable="loading"
          label="Delete Product"
          @click="ShowMoreDeleteModal()"
        />
        <q-space />
        <q-input
          dense
          rounded
          standout="bg-info text-white"
          v-model="search_text"
          input-class="text-right"
          class="q-ml-md"
        >
          <template v-slot:append>
            <q-icon v-if="search_text === ''" name="search" />
            <q-icon
              v-else
              name="clear"
              class="cursor-pointer"
              @click="search_text = ''"
            />
          </template>
        </q-input>
      </template>
    </q-table>
    <!-- Add Model -->
    <q-dialog v-model="AddModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendAddData"
        @keyup.esc="AddModalCancel()"
      >
        <q-card-section>
          <div class="text-h6">New Product</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Name</div>
          <q-input dense v-model="AddData.name" autofocus />
        </q-card-section>
        <q-card-section class="q-pt-none">
          <div class="text-h7">Category</div>
          <q-select
            filled
            v-model="AddData.category_id"
            :options="category"
            label="Select Roles"
            emit-value
            map-options
          />
        </q-card-section>
        <q-card-section class="q-pt-none">
          <q-uploader url="http://127.0.0.1:8000/api/products/upload" />
        </q-card-section>
        <q-card-section class="q-pt-none">
          <div class="text-h7">Describe</div>
          <q-input
            dense
            v-model="AddData.describe"
            autofocus
            filled
            type="textarea"
          />
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat label="Create" @click="SendAddData" />
          <q-btn flat label="Cancel" @click="AddModalCancel()" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Add Model -->
    <!-- Edit Model -->
    <q-dialog v-model="EditModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendEditData"
        @keyup.esc="EditModalCancel()"
      >
        <q-card-section>
          <div class="text-h6">Updata Product</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Name</div>
          <q-input dense v-model="EditData.name" autofocus />
        </q-card-section>
        <q-card-section class="q-pt-none">
          <div class="text-h7">Category</div>
          <q-select
            filled
            v-model="EditData.category_id"
            :options="category"
            label="Select Roles"
            emit-value
            map-options
          />
        </q-card-section>
        <q-card-section class="q-pt-none">
          <q-uploader url="http://127.0.0.1:8000/api/products/upload" />
        </q-card-section>
        <q-card-section class="q-pt-none">
          <div class="text-h7">Describe</div>
          <q-input
            dense
            v-model="EditData.describe"
            autofocus
            filled
            type="textarea"
          />
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat label="Create" @click="SendEditData" />
          <q-btn flat label="Cancel" @click="EditModalCancel()" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Edit Model -->
    <!-- Delete Dialog -->
    <q-dialog v-model="DeleteModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendDeleteData"
        @keyup.esc="DeleteModal = false"
      >
        <q-card-section>
          <div class="text-h6">Delete User</div>
        </q-card-section>

        <q-card-section>
          <div class="text-h7">You agree to delete this information?</div>
        </q-card-section>
        <q-card-section>
          <div class="text-h7">
            Name:{{ DeleteData.name }}
            <br />
            Category:{{ DeleteData.category.name }}
            <br />
            Describe:{{ DeleteData.describe }}
            <br />
            Image:
            <q-img :src="DeleteData.img" spinner-color="white" width="100px" />
            <br />
          </div>
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat color="negative" label="Delete" @click="SendDeleteData" />
          <q-btn flat label="Cancel" @click="DeleteModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Delete Dialog -->
    <!-- Start Multi Delete Modal  -->
    <q-dialog v-model="multiDeleteModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="selected.id"
        @keyup.esc="multiDeleteModal = false"
      >
        <q-card-section class="bg-deep-orange text-white">
          <div class="text-h6">Are you sure delete this products ?</div>
        </q-card-section>
        <q-form id="validates">
          <q-card-section class="q-pt-md">
            <div v-for="(selects, i) in selected" :key="i">
              <div class="row">
                <div class="row">
                  <p class="text-weight-bold q-pr-sm">{{ i + 1 }}. Name :</p>
                  {{ selects.name }}
                </div>
                <div class="row q-pl-md">
                  <p class="text-weight-bold q-pr-sm">Category :</p>
                  {{ selects.category.name }}
                </div>
                <div class="row q-pl-md">
                  <p class="text-weight-bold q-pr-sm">Describe :</p>
                  {{ selects.describe }}
                </div>
              </div>
            </div>
          </q-card-section>
        </q-form>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat color="red" label="Delete" @click="sendmultiDelete" />
          <q-btn flat label="Cancel" @click="multiDeleteModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Multi Delete Modal  -->
  </div>
</template>

<script>
import { defineComponent } from 'vue'
import axios from 'axios'
import { ref } from 'vue'

export default defineComponent({
  name: 'PageIndex',
  data() {
    return {
      password_error: false,
      search_text: '',
      category: [],
      products: [],
      selected: [],
      columns: [
        {
          name: 'index',
          label: '#',
          field: 'index',
          align: 'left',
          style: 'width: 10px',
          sortable: true,
        },
        {
          name: 'name',
          field: 'name',
          label: 'Products Name',
          align: 'left',
          sortable: true,
        },
        {
          name: 'img',
          field: 'img',
          label: 'Images',
          align: 'left',
          sortable: false,
        },
        {
          name: 'describe',
          field: 'describe',
          label: 'Describe',
          align: 'left',
          field: (row) => row.describe,
          format: (val) => `${val}`,
          sortable: false,
        },
        {
          name: 'category',
          field: 'category',
          label: 'Category',
          align: 'left',
          sortable: true,
        },
        {
          name: 'action',
          label: 'Action',
          align: 'left',
          style: 'width: 20px !important',
        },
      ],
      AddModal: false,
      AddData: {
        id: '',
        name: '',
        img: '/icons/favicon-128x128.png',
        category_id: '',
        describe: '',
      },
      EditModal: false,
      EditData: null,
      DeleteModal: false,
      DeleteData: null,
      multiDeleteModal: false,
    }
  },
  async mounted() {
    this.$q.loading.show()
    this.product()
    this.categorys()
  },

  methods: {
    factoryFn(files) {
      this.img = files
    },
    async product() {
      await axios
        .get('http://127.0.0.1:8000/api/products/')
        .then((response) => {
          var data = response.data.data
          //console.log(response.data.data)
          var j = []
          for (var i = 0; i < data.length; i++) {
            var json = {
              index: i,
              id: data[i].id,
              name: data[i].name,
              img: data[i].img,
              describe: data[i].describe,
              category: data[i].category,
            }
            j.push(json)
          }
          this.products = j
          if (data != null) {
            this.$q.loading.hide()
          }
        })
        .catch((e) => {
          console.log('tag')
          var res = e.response
          this.$q.loading.hide()
          if (res.status == 401) {
            this.auth()
          } else {
            this.$e('Something Errors')
          }
        })
    },
    async categorys() {
      await axios
        .get('http://127.0.0.1:8000/api/products/get_category')
        .then((response) => {
          var data = response.data
          console.log(data[0].id)
          for (var i = 0; i < data.length; i++) {
            var json = {
              value: data[i].id,
              label: data[i].name,
            }
            this.category.push(json)
          }
          console.log(this.category)
          if (response.data != null) {
            this.$q.loading.hide()
          }
        })
        .catch((e) => {
          console.log('tag')
          var res = e.response
          this.$q.loading.hide()
          if (res.status == 401) {
            this.auth()
          } else {
            this.$e('Something Errors')
          }
        })
    },
    ShowAddModal() {
      this.AddData.category_id = this.category[this.category.length - 1].value
      this.AddModal = true
    },

    AddModalCancel() {
      this.AddData = {
        id: '',
        name: '',
        email: '',
        role_id: '',
        password: '',
        return_password: '',
      }
      this.AddModal = false
    },

    async SendAddData() {
      if (this.AddData.name.length < 3) {
        this.$e('The name must be at least 3 characters.')
        return 0
      }
      if (this.AddData.img.length < 1) {
        this.$e('The img no empty')
        return 0
      }
      if (this.AddData.category_id.length < 0) {
        this.$e('The category no empty')
        return 0
      }
      if (this.AddData.describe.length < 3) {
        this.$e('The describe must be at least 3 characters.')
        return 0
      }
      this.$q.loading.show()
      await axios
        .post('http://127.0.0.1:8000/api/products/create_product', this.AddData)
        .then((res) => {
          //console.log(res.msg)
          if (res.status == 201) {
            this.$s('Succesfully Create Producs Data')
            this.$q.loading.hide()
            this.AddModal = false
            this.AddData = {
              id: '',
              name: '',
              img: '/icons/favicon-128x128.png',
              category_id: '',
              describe: '',
            }
          } else {
            this.$e('Something Errors')
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          var res = e.response
          if (res.status == 401) {
            this.auth()
          } else if (res.status == 422) {
            if (res.data.errors.name) {
              this.$e(res.data.errors.name[0])
            }
            if (res.data.errors.img) {
              this.$e(res.data.errors.img[0])
            }
            if (res.data.errors.password) {
              this.$e(res.data.errors.categorys[0])
            }
            if (res.data.errors.describe) {
              this.$e(res.data.errors.describe[0])
            }
          } else {
            this.$e('Something Error')
          }
        })
      this.product()
      this.categorys()
      this.$q.loading.hide()
    },
    async SendEditData() {
      if (this.EditData.name.length < 3) {
        this.$e('The name must be at least 3 characters.')
        return 0
      }
      if (this.EditData.img.length < 1) {
        this.$e('The img no empty')
        return 0
      }
      if (this.EditData.category_id.length < 1) {
        this.$e('The category no empty')
        return 0
      }
      if (this.EditData.describe.length < 3) {
        this.$e('The describe must be at least 3 characters.')
        return 0
      }
      this.$q.loading.show()
      await axios
        .post(
          'http://127.0.0.1:8000/api/products/update_product',
          this.EditData,
        )
        .then((res) => {
          //console.log(res.msg)
          if (res.status == 200) {
            this.$s('Succesfully Update Producs Data')
            this.EditModal = null
            this.$q.loading.hide()
            this.EditModal = false
          } else {
            this.$q.loading.hide()
            this.$e('Something Errors')
          }
        })
        .catch((e) => {
          var res = e.response
          if (res.status == 401) {
            this.auth()
          } else {
            this.$e('Something Errors')
          }
        })
      this.$q.loading.hide()
      this.product()
      this.categorys()
    },
    ShowEditModal(data) {
      this.EditModal = true
      this.EditData = {
        id: data.id,
        name: data.name,
        img: data.img,
        category_id: data.category.id,
        describe: data.describe,
      }
    },
    EditModalCancel() {
      this.EditData = null
      this.EditModal = false
    },
    ShowDeleteModal(row) {
      this.DeleteData = row
      this.DeleteModal = true
    },
    async SendDeleteData() {
      this.$q.loading.show()
      var da = {
        id: this.DeleteData.id,
      }
      await axios
        .post('http://127.0.0.1:8000/api/products/delete_product', da)
        .then((res) => {
          //console.log(res.msg)
          if (res.status == 200) {
            this.$s('Succesfully Delete User')
            this.DeleteModal = false
          }
        })
        .catch((e) => {
          var res = e.response
          if (res.status == 401) {
            this.auth()
          } else {
            this.$e('Something Error')
          }
        })
      this.product()
      this.categorys()
      this.$q.loading.hide()
    },
    ShowMoreDeleteModal() {
      this.multiDeleteModal = true
    },
    async sendmultiDelete() {
      this.$q.loading.show()
      let sender = JSON.stringify(this.selected)
      await axios
        .post('http://127.0.0.1:8000/api/products/multidelete', {
          data: sender,
        })
        .then((res) => {
          //console.log(res.msg)
          if (res.status == 200) {
            this.$s('Succesfully Delete User')
            this.multiDeleteModal = false
          }
        })
        .catch((e) => {
          var res = e.response
          if (res.status == 401) {
            this.auth()
          } else {
            this.$e('Something Error')
          }
        })
      this.product()
      this.categorys()
      this.$q.loading.hide()
    },
    auth() {
      this.$e('You are not authorized')
      this.$router
        .push('/login')
        .then((s) => {})
        .catch((e) => {})
    },
  },
})
</script>
